<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" content="width=device-width, initial-scale=1.0">
    <title>selectbox country</title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
</head>

<body>

    <div class="container">
        <h2>Responsive Form</h2>
        <p>sample forms 02: multi colums</p>

        <form action="" class="jumbotron container" id="input-form">
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="fname">First Name</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="fname" name="firstname" placeholder="Your name.." class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="lname">Last Name</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="lname" name="lastname" placeholder="Your last name.." class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="country">Country</label>
                </div>
                <div class="col-sm-3">
                    <select id="country-select" name="country" class="form-control">
                    </select>
                </div>
                <div class="col-sm-3">
                    <label for="region">Region</label>
                </div>
                <div class="col-sm-3">
                    <select id="region-select" disabled name="region" class="form-control">
                    </select>
                </div>
            </div>
            <div class="row pull-right">
                <div class="col-sm-12">
                    <input type="button" value="Send" class="btn btn-info" id="send-button">
                </div>
            </div>
        </form>
    </div>

    <script>

        //get data country
        $.ajax({
            url: "http://localhost:8080/countries",
            type: "GET",
            success: function (res) {
                console.log(res)
                loadDataToCountrySelect(res)
            },
            error: function (err) {
                console.log(err.status);
            }
        })

        var gSelectCountry = $("#country-select");
        //load data to select
        function loadDataToCountrySelect(paramCountry) {

            for (let i = 0; i < paramCountry.length; i++) {
                let bOptionCountry = $("<option>")
                bOptionCountry.val(paramCountry[i].countryCode);
                bOptionCountry.text(paramCountry[i].countryName);

                gSelectCountry.append(bOptionCountry);
            }
        }

        var gRegionSelectElement = $("#region-select");

        //callback function
        gSelectCountry.on("change", function () {
            gRegionSelectElement.html("");
            var bCountryCode = $(this).val();

            getRegionsByCountryCode(bCountryCode);
        });

        function getRegionsByCountryCode(pCountryCode) {
            $.ajax({
                url: "http://localhost:8080/regions?countryCode=" + pCountryCode,
                method: "GET",
                success: function (pObjRes) {
                    console.log(pObjRes);
                    loadDataToRegionSelect(pObjRes);
                },
                error: function (pXhrObj) {
                    console.log(pXhrObj);
                }
            });
        }

        function loadDataToRegionSelect(pRegionList) {
            if (pRegionList.length > 0) {
                gRegionSelectElement.prop("disabled", false);

                for (i = 0; i < pRegionList.length; i++) {
                    var bRegionOption = $("<option/>");
                    bRegionOption.prop("value", pRegionList[i].regionCode);
                    bRegionOption.prop("text", pRegionList[i].regionName);
                    gRegionSelectElement.append(bRegionOption);
                };
            } else {
                gRegionSelectElement.prop("disabled", "disabled");
            }
        }



    </script>
</body>

</html>